<?php
require_once(PATH_t3lib.'class.t3lib_rteapi.php');
require_once(PATH_t3lib.'class.t3lib_cs.php');

class tx_tinyrte_base extends t3lib_rteapi {

	/**
	 * Is the browser able to display the RTE? (Not implemented yet. Coming soon...
	 */
	function isAvailable()	{


	return true;
	}


	/**
	 * Draws the RTE
	 *
	 * @param	object		Reference to parent object, which is an instance of the TCEforms.
	 * @param	string		The table name
	 * @param	string		The field name
	 * @param	array		The current row from which field is being rendered
	 * @param	array		Array of standard content for rendering form fields from TCEforms. See TCEforms for details on this. Includes for instance the value and the form field name, java script actions and more.
	 * @param	array		"special" configuration - what is found at position 4 in the types configuration of a field from record, parsed into an array.
	 * @param	array		Configuration for RTEs; A mix between TSconfig and otherwise. Contains configuration for display, which buttons are enabled, additional transformation information etc.
	 * @param	string		Record "type" field value.
	 * @param	string		Relative path for images/links in RTE; this is used when the RTE edits content from static files where the path of such media has to be transformed forth and back!
	 * @param	integer		PID value of record (true parent page id)
	 * @return	string		HTML code for RTE!
	 */
	function drawRTE(&$pObj,$table,$field,$row,$PA,$specConf,$thisConfig,$RTEtypeVal,$RTErelPath,$thePidValue)	{
		global $BE_USER,$LANG,$TCA;
 		$tf=array(
			"0" => "false",
			"1" => "true",
		);
		/**
		 * get the language
		 */
		$this->language = $LANG->lang;
		if ($this->language=='default' || !$this->language)	{
			$this->language='en';
		}

		/**
		 * Path
		 */
		$this->httpTypo3Path = substr( substr( t3lib_div::getIndpEnv('TYPO3_SITE_URL'), strlen( t3lib_div::getIndpEnv('TYPO3_REQUEST_HOST') ) ), 0, -1 );
		if (strlen($this->httpTypo3Path) == 1) {
			$this->httpTypo3Path = "/";
		} else {
			$this->httpTypo3Path .= "/";
		}
		$this->Path = $this->httpTypo3Path . t3lib_extMgm::siteRelPath("tinyrte");




		/**
		 * Configure the RTE
		 */ 
		$globalConf=unserialize($GLOBALS["TYPO3_CONF_VARS"]["EXT"]["extConf"]["tinyrte"]);
		$css='../'.$globalConf["MCEstyle"];

		/**
		 * Gets permissions from groups and user or select all if user is admin AND buttons are not configured
		 */
		if($BE_USER->user[admin] && $BE_USER->user[tx_tinyrte_tinyrte_plugins]=="") {
			$MCEConfig="";
			while (list(,$val) = each($TCA[be_groups][columns][tx_tinyrte_tinyrte_plugins][config][items])) {
				if($val[1]!="") $MCEConfig.=$val[1].",";
			}
		}
		else {
			while (list($key,) = each($BE_USER->userGroups)) {
				$groupConfig.=$BE_USER->userGroups[$key][tx_tinyrte_tinyrte_plugins].",";
			}
			$MCEConfig=str_replace(",,",",",$groupConfig.$BE_USER->user[tx_tinyrte_tinyrte_plugins]);
		}
	
		$value = $this->transformContent('rte',$PA['itemFormElValue'],$table,$field,$row,$specConf,$thisConfig,$RTErelPath,$thePidValue);
		/**
		 * Go on if there buttons configured
		 */ 
		if(strlen($MCEConfig)>2){
			/**
			 * override all configuration with values from TS-Config
			 */ 
			$TS=t3lib_befunc::getPagesTSconfig($thePidValue);
			$thisConfig=$TS["RTE."]["default."];


			if($thisConfig["disableColorPicker"]==1) $thisConfig["hideButtons"].=",forecolor,backcolor";



			$hideButtons=explode(",",str_replace(" ","",$thisConfig["hideButtons"]));
			$showButtons=explode(",",str_replace(" ","",$thisConfig["showButtons"]));
			while (list(,$val) = each($showButtons)) { // adds the buttons from TSConfig to groups & users
				if(!strstr($MCEConfig,$val.",") || !strstr($MCEConfig,",".$val)) $MCEConfig.=",".$val;
			}
			$allButtons=explode(",",$MCEConfig);
			$MCEConfig="";
			while (list(,$val) = each($allButtons)) { // remove the buttons from TSConfig from groups & users
				if(!in_array($val,$hideButtons)) $MCEConfig.=$val.",";
			}
			$MCEConfig=substr($MCEConfig,0,strlen($MCEConfig)-1);
			$css=$thisConfig["cssFile"] ? "../".$thisConfig["cssFile"] : $css; // override css
	
			/**
			 * Plugins to load
			 */
			$allowed=explode(",",$MCEConfig);
			$MCEConfig="";
			while (list(,$val) = each($allowed)) { // if this really a loadable Plugin?
				if($val=="rtl" || $val=="ltr") $val="directionality";
				if($val=="insertdate" || $val=="inserttime") $val="insertdatetime";
				if($val=="search" || $val=="replace") $val="searchreplace";
				$plug=t3lib_div::getIndpEnv("TYPO3_DOCUMENT_ROOT").$this->Path."tiny_mce/plugins/".$val."/editor_plugin.js";
				if($val && file_exists($plug) && !in_array($val,explode(",",$MCEConfig))) {
					if(($GLOBALS['TYPO_VERSION']<"5.0" && $val=="inlinepopups") || ($val!="inlinepopups")) $MCEConfig.=$val.",";
				}
			}
			$globalConf["MCEplugin"]=substr($MCEConfig,0,strlen($MCEConfig)-1);
	
	
			/**
			 * Remove not allowed Buttons
			 */
			$Cset=explode(",",$globalConf["MCEbuttons1"].",".$globalConf["MCEbuttons2"].",".$globalConf["MCEbuttons3"].",".$globalConf["MCEbuttons4"]);
			for ($i = 1; $i <= 4; $i++) {
				$set=explode(",",$globalConf["MCEbuttons".$i]);
				$globalConf["MCEbuttons".$i]="";
				while (list(,$val) = each($set)) {
					if($val=="|") {
						$globalConf["MCEbuttons".$i].=$val.",";
					}
					else {
						if($val!="table" || ($val=="table" && (!in_array("tablecontrols", $Cset) || !in_array("tablecontrols",$allowed)))) { //Remove button "table" if "tablecontrols" include
							if(in_array($val,$allowed)) $globalConf["MCEbuttons".$i].=$val.",";
							if($val=="tablecontrols" && !in_array("table",explode(",",$globalConf["MCEplugin"]))) $globalConf["MCEplugin"].=",table"; // table is disabled but tablecontrols enabled, we must load the plugin "table"
						}
					}
				}
				$globalConf["MCEbuttons".$i]=substr($globalConf["MCEbuttons".$i],0,strlen($globalConf["MCEbuttons".$i])-1);
			}

			
			/**
			 * Remove double commatas
			 */
			for ($i = 1; $i <= 4; $i++) {
				$globalConf["MCEbuttons".$i]=str_replace(",,",",",$globalConf["MCEbuttons".$i]);
				if(substr($globalConf["MCEbuttons".$i],0,1)==",") $globalConf["MCEbuttons".$i]=substr($globalConf["MCEbuttons".$i],1,strlen($globalConf["MCEbuttons".$i]));
			}
	
	
	
			/**
			 * Remove double separators
			 */
			for ($i = 1; $i <= 4; $i++) {
				unset($d);
				while (!$d) {
					if(!strstr($globalConf["MCEbuttons".$i],"|,|")) $d=true;
					$globalConf["MCEbuttons".$i]=str_replace("|,|","|",$globalConf["MCEbuttons".$i]);
				}
			}
	
			/**
			 * Load the RTE
			 */
			$item='
			<script language="javascript" type="text/javascript" src="'.$this->Path.'tiny_mce/tiny_mce.js"></script>
			<script language="javascript" type="text/javascript">
				tinyMCE.init({
					cleanup : true,
					remove_script_host : false,
					relative_urls : false,
					mode : "exact",
					extended_valid_elements : "hr[class|width|size|noshade],help",
					file_browser_callback : "fileBrowserCallBack",
					elements : "RTEarea'.$pObj->RTEcounter.'",
					theme : "advanced",
					language : "'.$this->language.'",
					entities : "'.$globalConf["MCEentities"].'",
					width : "'.$globalConf["MCEwidth"].'",
					height : "'.$globalConf["MCEheight"].'",
					convert_newlines_to_brs : '.$tf[$globalConf["MCEconvert_newlines_to_brs"]].',
					force_p_newlines : '.$tf[$globalConf["MCEforce_p_newlines"]].',
					force_br_newlines : '.$tf[$globalConf["MCEforce_br_newlines"]].',
					content_css : "'.$css.'",
					theme_advanced_resizing : '.$tf[$globalConf["MCEtheme_advanced_resizing"]].',
					theme_advanced_resize_horizontal : '.$tf[$globalConf["MCEtheme_advanced_resize_horizontal"]].',
					theme_advanced_buttons1 : "'.str_replace("|","separator",$globalConf["MCEbuttons1"]).'",
					theme_advanced_buttons2 : "'.str_replace("|","separator",$globalConf["MCEbuttons2"]).'",
					theme_advanced_buttons3 : "'.str_replace("|","separator",$globalConf["MCEbuttons3"]).'",
					theme_advanced_buttons4 : "'.str_replace("|","separator",$globalConf["MCEbuttons4"]).'",
					theme_advanced_toolbar_location : "top",
					theme_advanced_toolbar_align : "left",
					theme_advanced_statusbar_location : "bottom",
				   	plugin_insertdate_dateFormat : "'.$globalConf["MCEplugin_insertdate_dateFormat"].'",
				   	plugin_insertdate_timeFormat : "'.$globalConf["MCEplugin_insertdate_timeFormat"].'",
					plugins : "'.$globalConf["MCEplugin"].'",
					invalid_elements : "'.$globalConf["MCEplugin_invalid"].'",
					verify_html : true,
					//encoding : "xml", 
					cleanup_on_startup : true,
					//paste_use_dialog : true
					theme_advanced_styles : "'.$thisConfig["classes"].'",
					theme_advanced_fonts : "'.$globalConf["MCEoption_theme_advanced_fonts"].'",
					apply_source_formatting : true,
					spellchecker_languages : "+Deutsch=de,Englisch=en"
				});
	
			
				
				/**
				 * Here are the additional Typo3-Functions
				 * At this time only "type" is used to
				 * manage Link or Image functions
				 */
				function fileBrowserCallBack(field_name, url, type, win) {
					field=field_name;
					wObject=win;
					var template = new Array();
					template["width"] = 500;
					template["height"] = 300;
					template["close_previous"] = "no";
					var editor_id="RTEarea'.$pObj->RTEcounter.'";
					switch(type){
						case "link":
							var curr="";
							var act="page";
							var selURL="";
							var current="";
							node=tinyMCE.selectedElement;
							do {
								if (node.nodeName.toLowerCase() == "a" && tinyMCE.getAttrib(node, "href") != "") {
									curr=tinyMCE.getAttrib(node, "href");
									if(curr.indexOf("?id=")<0) {
										if(curr.indexOf("mailto:")>-1) {
											act="mail";
										}
										else if(curr.indexOf("http://")>-1) {
											act="url";
										}
										else if(curr.indexOf("file:")>-1) {
											act="file";
										}
										var selURL=tinyMCE.getAttrib(node, "href");
										current="&P[currentValue]="+selURL.replace(\'file:\',\'http:\')+" "+tinyMCE.getAttrib(node, "target"); //+"&curUrl[href]="+tinyMCE.getAttrib(node, "href")+"&curUrl[target]="+tinyMCE.getAttrib(node, "target");
									}
									else {
										var fz=curr.indexOf("?")+4;
										selURL=curr.substr(fz,curr.length);
										current="&P[currentValue]="+selURL;
									}
									break;
								}
							} while ((node = node.parentNode));
							template["file"] = "'.$this->Path.'mod1/browse_links.php?act="+act+"&mode=wizard&P[ext]=../'.t3lib_extMgm::siteRelPath("tinyrte").'&P[init]=tinyrte&P[formName]=editform"+current+"&P[itemName]=data%5B'.$table.'%5D%5B'.$row["uid"].'%5D%5B'.$field.'%5D&P[fieldChangeFunc][setTheValue]=setTheValue%28\'link\',input,document.location.search%29%3B&P[fieldChangeFunc][TBE_EDITOR_fieldChanged]=TBE_EDITOR_fieldChanged%28%27'.$table.'%27%2C%27'.$row["uid"].'%27%2C%27'.$field.'%27%2C%27data%5B'.$table.'%5D%5B'.$row["uid"].'%5D%5B'.$field.'%5D%27%29%3B";
							tinyMCE.openWindow(template, {editor_id : editor_id, scrollbars : "yes", inline : "yes"});
							return false;
	
						case "image":
							template["file"] = "'.$this->Path.'rte_select_image.php?&RTEtsConfigParams='.$table.'%3A136%3A'.$field.'%3A29%3Atext%3A'.$row["pid"].'%3A";
							tinyMCE.openWindow(template, {editor_id : editor_id, scrollbars : "yes", inline : "yes"});
							return false;
					}
				}
				/**
				 * If an Link or Image selected, insert in the RTE
				 * This function is called from the Elementbrowser.
				 *
				 * type		: Link or Image
				 * value	: The value to be inserted
				 * act		: Needed for Links, to transform the kind of link (internal, external, file, email)
				 *
				 * The "act"-Value we become from the URL of the Elementbrowser
				 */ 
				function setTheValue(type,value,act) {
					switch(type){
						case "link":
							var prefixURL=getActivePagefromFilebrowser(act);
							var linkValue=value.split(" ");
							var linkURL=linkValue[0];
							var target=linkValue[1];
							if(target.indexOf("x")!=-1) { // Opens the link in a window with window.open....
								var winProp=target.split("x");
								var klick="window.open(\'"+prefixURL+linkURL+"\',\'popup\',\'height="+winProp[0]+",width="+winProp[1]+"\')";
								linkURL="#";
								tinyMCE.themes["advanced"]._insertLink(linkURL, "", "", klick);
							}
							else { 
								tinyMCE.themes["advanced"]._insertLink(prefixURL+linkURL, target);
							}
							break;
						case "image":
							var imageProp=value.split("|");
							if(field) {
								wObject.document.getElementById(field).value=imageProp[0];
							}
							else {
								tinyMCE.themes["advanced"]._insertImage(imageProp[0], "", "", "", "", imageProp[1], imageProp[2], "", "", "", "");
								TBE_EDITOR_fieldChanged(\''.$table.'\',\''.$row["uid"].'\',\''.$field.'\',\'data['.$table.']['.$row["uid"].']['.$field.']\');
							}
							break;
					}
				}
	
				/**
				 * What kind of link we get back?
		 		 */
				function getActivePagefromFilebrowser(act) {
					if(act.indexOf("act=page")>-1) {
						return "'.t3lib_div::getIndpEnv('TYPO3_SITE_URL').'?id=";
					}
					else if(act.indexOf("act=file")>-1) {
						return "'.str_replace("http://","file://",t3lib_div::getIndpEnv('TYPO3_SITE_URL')).'";
					}
					else if(act.indexOf("act=url")>-1) {
						return "http://";
					}
					else if(act.indexOf("act=mail")>-1) {
						return "mailto:";
					}
					else {
						alert("Cant specify the kind of Link. Sorry!");
					}
					return;
				}
			</script>
			'.$this->triggerField($PA['itemFormElName']).'
			<textarea id="RTEarea'.$pObj->RTEcounter.'" name="'.htmlspecialchars($PA['itemFormElName']).'" rows="15" cols="80">'.t3lib_div::formatForTextarea($value).'</textarea>';
		}
		else {
			/**
			 * No buttons configured for the actual user
			 */
			$item='
			<script language="javascript" type="text/javascript">
				alert("RTE is disabled.\\n\\nReason:\\nThe Administrator has no Buttons configured for you .\\nPlease inform your Administrator of Typo3 to enable some\\nButtons for you to use the RTE.");
			</script>
			'.$this->triggerField($PA['itemFormElName']).'
			<textarea id="RTEarea'.$pObj->RTEcounter.'" name="'.htmlspecialchars($PA['itemFormElName']).'" rows="15" cols="80">'.t3lib_div::formatForTextarea($value).'</textarea>';
		}
		return $item;
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tinyrte/class.tx_tinyrte_base.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tinyrte/class.tx_tinyrte_base.php']);
}
?>